package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.EffectBlockGUI1Menu;
import net.mcreator.puzzle_code.procedures.ReturnPowerEffectProcedure;
import net.mcreator.puzzle_code.procedures.ReturnDurationEffectTicksProcedure;
import net.mcreator.puzzle_code.procedures.ReturnBlockNameProcedure;
import net.mcreator.puzzle_code.procedures.ParticlesDisplayOffProcedure;
import net.mcreator.puzzle_code.procedures.AmbientDisplayOffProcedure;
import net.mcreator.puzzle_code.network.EffectBlockGUI1ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class EffectBlockGUI1Screen extends AbstractContainerScreen<EffectBlockGUI1Menu> {
	private final static HashMap<String, Object> guistate = EffectBlockGUI1Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_edit_button;
	ImageButton imagebutton_edit_button1;
	ImageButton imagebutton_tab_potion;
	ImageButton imagebutton_tab_redstone_deselected;
	ImageButton imagebutton_tab_interaction_deselected;
	ImageButton imagebutton_on_button;
	ImageButton imagebutton_off_button;
	ImageButton imagebutton_question_mark_button;
	ImageButton imagebutton_on_button1;
	ImageButton imagebutton_off_button1;
	ImageButton imagebutton_question_mark_button1;

	public EffectBlockGUI1Screen(EffectBlockGUI1Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 161;
		this.imageHeight = 145;
	}

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 55 && mouseX < leftPos + 75 && mouseY > topPos + 85 && mouseY < topPos + 105)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.effect_block_gui_1.tooltip_nbtambient"), mouseX, mouseY);
		if (mouseX > leftPos + 128 && mouseX < leftPos + 148 && mouseY > topPos + 85 && mouseY < topPos + 105)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.effect_block_gui_1.tooltip_nbtparticles"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/effect_block_gui_1.png"), this.leftPos + 0, this.topPos + 0, 0, 0, 161, 116, 161, 116);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.effect_block_gui_1.label_power"), 40, 23, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.effect_block_gui_1.label_duration"), 110, 25, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnPowerEffectProcedure.execute(world, x, y, z), 9, 44, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDurationEffectTicksProcedure.execute(world, x, y, z), 83, 44, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.effect_block_gui_1.label_ambient"), 24, 67, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.effect_block_gui_1.label_particles"), 96, 67, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnBlockNameProcedure.execute(world, x, y, z), 9, 7, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_edit_button = new ImageButton(this.leftPos + 10, this.topPos + 20, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/settings_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/settings_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(0, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 0, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button", imagebutton_edit_button);
		this.addRenderableWidget(imagebutton_edit_button);
		imagebutton_edit_button1 = new ImageButton(this.leftPos + 83, this.topPos + 20, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/settings_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/settings_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(1, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button1", imagebutton_edit_button1);
		this.addRenderableWidget(imagebutton_edit_button1);
		imagebutton_tab_potion = new ImageButton(this.leftPos + 0, this.topPos + 113, 32, 32,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/tab_potion.png"), ResourceLocation.parse("puzzle_code:textures/screens/tab_potion.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(2, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_tab_potion", imagebutton_tab_potion);
		this.addRenderableWidget(imagebutton_tab_potion);
		imagebutton_tab_redstone_deselected = new ImageButton(this.leftPos + 65, this.topPos + 113, 32, 32,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/tab_redstone_deselected.png"), ResourceLocation.parse("puzzle_code:textures/screens/tab_redstone_deselected.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(3, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 3, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_tab_redstone_deselected", imagebutton_tab_redstone_deselected);
		this.addRenderableWidget(imagebutton_tab_redstone_deselected);
		imagebutton_tab_interaction_deselected = new ImageButton(this.leftPos + 128, this.topPos + 113, 32, 32,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/tab_interaction_deselected.png"), ResourceLocation.parse("puzzle_code:textures/screens/tab_interaction_deselected.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(4, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 4, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_tab_interaction_deselected", imagebutton_tab_interaction_deselected);
		this.addRenderableWidget(imagebutton_tab_interaction_deselected);
		imagebutton_on_button = new ImageButton(this.leftPos + 10, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(5, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 5, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button", imagebutton_on_button);
		this.addRenderableWidget(imagebutton_on_button);
		imagebutton_off_button = new ImageButton(this.leftPos + 10, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (AmbientDisplayOffProcedure.execute(world, x, y, z)) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(6, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 6, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (AmbientDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button", imagebutton_off_button);
		this.addRenderableWidget(imagebutton_off_button);
		imagebutton_question_mark_button = new ImageButton(this.leftPos + 55, this.topPos + 85, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button", imagebutton_question_mark_button);
		this.addRenderableWidget(imagebutton_question_mark_button);
		imagebutton_on_button1 = new ImageButton(this.leftPos + 83, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(8, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 8, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button1", imagebutton_on_button1);
		this.addRenderableWidget(imagebutton_on_button1);
		imagebutton_off_button1 = new ImageButton(this.leftPos + 83, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (ParticlesDisplayOffProcedure.execute(world, x, y, z)) {
						PacketDistributor.sendToServer(new EffectBlockGUI1ButtonMessage(9, x, y, z));
						EffectBlockGUI1ButtonMessage.handleButtonAction(entity, 9, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (ParticlesDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button1", imagebutton_off_button1);
		this.addRenderableWidget(imagebutton_off_button1);
		imagebutton_question_mark_button1 = new ImageButton(this.leftPos + 128, this.topPos + 85, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button1", imagebutton_question_mark_button1);
		this.addRenderableWidget(imagebutton_question_mark_button1);
	}
}
